<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'vote';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/vote/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 载入并实例化类库
require (ROOT_PATH . 'include/vote.class.php');
$dou_vote = new Vote();

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 投票列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['vote']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['vote_add'],
            'href' => 'vote.php?rec=add' 
    ));
    
    // 获取参数
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    
    // 筛选条件
    if ($keyword) {
        $where = " WHERE name LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('vote') . $where . " ORDER BY vote_id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, 'vote.php?rec=vote_list', $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $vote_list[] = array (
                "vote_id" => $row['vote_id'],
                "name" => $row['name'],
                "max_vote_number" => $row['max_vote_number'],
                "start_time" => date("Y-m-d H:i:s", $row['start_time']),
                "end_time" => date("Y-m-d H:i:s", $row['end_time']),
                "status" => $dou->data_lang_format('vote_status_', $row['status']),
                "url_vote" => $dou->param($dou->rewrite_url('vote') . '&vote_id=' . $row['vote_id']),
                "url_rank" => $dou->param($dou->rewrite_url('vote', 'rank') . '&vote_id=' . $row['vote_id']),
                "url_detail" => $dou->param($dou->rewrite_url('vote', 'detail') . '&vote_id=' . $row['vote_id']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
   
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('vote_list', $vote_list);
    
    $smarty->display('vote.htm');
} 

/**
 * +----------------------------------------------------------
 * 投票添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['vote_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['vote'],
            'href' => 'vote.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
 
    // 初始化投票时间
    $vote['start_time'] = date("Y-m-d H:i:s", time());
    $vote['end_time'] = date("Y-m-d H:i:s", strtotime("+30day", time()));
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('item_id', $dou->auto_id('vote'));
    $smarty->assign('vote', $vote);
    $smarty->assign('btn_lang', $dou->btn_lang('vote', '', 'name, content, keywords, description'));
    
    $smarty->display('vote.htm');
} 

elseif ($rec == 'insert') {
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['vote_name'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('vote', $dou->auto_id('vote'), 'image', 'main');

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    // 格式化数据
    $start_time = $_POST['start_time'] ? strtotime($_POST['start_time']) : '';
    $end_time = $_POST['end_time'] ? strtotime($_POST['end_time']) : '';
    
    $sql = "INSERT INTO " . $dou->table('vote') . " (vote_id, name, unique_id, content, image, max_vote_number, start_time, end_time, back_url, status)" . " VALUES (NULL, '$_POST[name]', '$_POST[unique_id]', '$_POST[content]', '$image', '$_POST[max_vote_number]', '$start_time', '$end_time', '$_POST[back_url]', '$_POST[status]')";
    $dou->query($sql);
 
    // 生成二维码图片
    $dou_vote->create_qrcode($dou->insert_id());
    
    $dou->create_admin_log($_LANG['vote_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['vote_add'] . $_LANG['success'], 'vote.php');
} 

/**
 * +----------------------------------------------------------
 * 投票编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['vote_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['vote_list'],
            'href' => 'vote.php?rec=vote_list' 
    ));
 
    // 验证并获取合法的ID
    $vote_id = $check->is_number($_REQUEST['vote_id']) ? $_REQUEST['vote_id'] : '';
    
    // 获取投票信息
    $vote = $dou->get_row('vote', '*', "vote_id = '$vote_id'");
    $vote['start_time'] = $vote['start_time'] ? date("Y-m-d H:i:s", $vote['start_time']) : date("Y-m-d H:i:s", time());
    $vote['end_time'] = $vote['end_time'] ? date("Y-m-d H:i:s", $vote['end_time']) : date("Y-m-d H:i:s", strtotime("+30day", time()));
    $vote['image'] = $dou->dou_file($vote['image']);
    
    // 赋值给模板
    $smarty->assign('vote_option_list', $dou_vote->get_vote_option_list($vote_id));
    
    // 自定义选项添加
    if ($act == 'option_add') {
        // 赋值给模板
        $smarty->assign('option_vote_action', 'option_insert');
        $smarty->assign('vote_option_type', $dou->data_list_lang_format('vote_option_type_', 'input, select, textarea, radio'));
    }
 
    // 自定义选项编辑
    elseif ($act == 'option_edit') {
        // 获取REQUEST
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        
        $option = $dou->get_row('vote_option', '*', "id = '$id'");
        
        // 赋值给模板
        $smarty->assign('option', $option);
        $smarty->assign('option_vote_action', 'option_update');
        $smarty->assign('vote_option_type', $dou->data_list_lang_format('vote_option_type_', 'input, select, textarea, radio', $option['type']));
    } 
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('vote', $vote);
    $smarty->assign('item_id', $vote_id);
    $smarty->assign('item_content', $vote['content']);
    $smarty->assign('btn_lang', $dou->btn_lang('vote', $vote_id, 'name, content, keywords, description'));
    
    $smarty->display('vote.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $vote_id = $check->is_number($_POST['vote_id']) ? $_POST['vote_id'] : '';
    
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['vote_name'] . $_LANG['is_empty']);

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    // 文件上传盒子
    $image = $file->box('vote', $vote_id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';
    
    // 格式化数据
    $start_time = $_POST['start_time'] ? strtotime($_POST['start_time']) : '';
    $end_time = $_POST['end_time'] ? strtotime($_POST['end_time']) : '';
    
    $sql = "UPDATE " . $dou->table('vote') . " SET name = '$_POST[name]', unique_id = '$_POST[unique_id]', content = '$_POST[content]'" . $image . ", max_vote_number = '$_POST[max_vote_number]', start_time = '$start_time', end_time = '$end_time', back_url = '$_POST[back_url]', status = '$_POST[status]' WHERE vote_id = '$vote_id'";
    $dou->query($sql);
    
    // 生成二维码图片
    $dou_vote->create_qrcode($vote_id);
    
    $dou->create_admin_log($_LANG['vote_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['vote_edit_succes'], 'vote.php');
}

/**
 * +----------------------------------------------------------
 * 投票删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $vote_id = $check->is_number($_REQUEST['vote_id']) ? $_REQUEST['vote_id'] : $dou->dou_msg($_LANG['illegal'], 'vote.php');
    $name = $dou->get_one("SELECT name FROM " . $dou->table('vote') . " WHERE vote_id = '$vote_id'");
    
    if (isset($_POST['confirm'])) {
        // 删除相应商品图片
        $image = $dou->get_one("SELECT image FROM " . $dou->table('vote') . " WHERE vote_id = '$vote_id'");
        $dou->del_file($image);
         
        // 删除对应语言项
        if ($_OPEN['language'])
            $dou->del_lang_value('vote', $id);
        
        $dou->create_admin_log($_LANG['vote_del'] . ': ' . $name);
        $dou->delete('vote', "vote_id = $vote_id", 'vote.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'vote.php', '', '30', "vote.php?rec=del&vote_id=$vote_id");
    }
}


/**
 * +----------------------------------------------------------
 * 候选列表
 * +----------------------------------------------------------
 */
elseif ($rec == 'option') {
    $act = $check->is_rec($_REQUEST['act']) ? $_REQUEST['act'] : 'add';
    
    // 获取投票信息
    $vote_id = $check->is_number($_REQUEST['vote_id']) ? $_REQUEST['vote_id'] : '';
    $vote = $dou->get_row('vote', '*', "vote_id = '$vote_id'");
    
    $smarty->assign('ur_here', $vote['name'] . ' ' . $_LANG['vote_option_list']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['vote_list'],
            'href' => 'vote.php?rec=vote_list' 
    ));
 
    // 赋值给模板
    $smarty->assign('vote_option_list', $dou_vote->get_vote_option_list($vote_id));
 
    // 自定义选项添加
    if ($act == 'add') {
        // 自增编号
        $option_number = $dou->get_one("SELECT number FROM " . $dou->table('vote_option') . " WHERE vote_id = '$vote_id' ORDER BY number DESC, option_id DESC") + 1;

        // 赋值给模板
        $smarty->assign('option_number', $option_number);
        $smarty->assign('option_action', 'option_insert');
    }

    // 自定义选项编辑
    elseif ($act == 'edit') {
        // 获取REQUEST
        $option_id = $check->is_number($_REQUEST['option_id']) ? $_REQUEST['option_id'] : '';

        $vote_option = $dou->get_row('vote_option', '*', "option_id = '$option_id'");
    
        // 格式化数据
        $vote_option['image'] = $dou->dou_file($vote_option['image']);

        // 赋值给模板
        $smarty->assign('vote_option', $vote_option);
        $smarty->assign('option_action', 'option_update');
    } 
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('vote_id', $vote_id);
    $smarty->assign('act', $act);
    
    $smarty->display('vote.htm');
}

/**
 * +----------------------------------------------------------
 * 自定义选项添加处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'option_insert') {
    // 获取合法的ID
    $vote_id = $check->is_number($_REQUEST['vote_id']) ? $_REQUEST['vote_id'] : '';
 
    // 图片上传
    include_once (ROOT_PATH . 'include/file.class.php');
    $file = new File('images/vote_option/'); // 实例化类文件(文件上传路径，结尾加斜杠)
                                                        
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['vote_option_name'] . $_LANG['is_empty']);

    // 验证是否上传证书
    if (empty($_FILES['image']['name'])) $dou->dou_msg($_LANG['certificate_image'] . $_LANG['is_empty']);

    // 文件上传盒子
    $image = $file->box('vote_option', $dou->auto_id('vote_option'), 'image', 'main', null, null, null, null, null, 'option_id');

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);

    $sql = "INSERT INTO " . $dou->table('vote_option') . " (option_id, vote_id, name, image, content, number, sort)" . " VALUES (NULL, '$vote_id', '$_POST[name]', '$image', '$_POST[content]', '$_POST[number]', '$_POST[sort]')";
    $dou->query($sql);

    $dou->create_admin_log($_LANG['vote_option_add'] . ': ' . $_POST['name']);
    $dou->dou_header('vote.php?rec=option&vote_id=' . $_POST['vote_id']);
}

/**
 * +----------------------------------------------------------
 * 自定义选项编辑处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'option_update') {
    // 获取合法的ID
    $option_id = $check->is_number($_REQUEST['option_id']) ? $_REQUEST['option_id'] : '';
 
    // 图片上传
    include_once (ROOT_PATH . 'include/file.class.php');
    $file = new File('images/vote_option/'); // 实例化类文件(文件上传路径，结尾加斜杠)
                                                        
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['vote_option_name'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('vote_option', $option_id, 'image', 'main', null, null, null, null, null, 'option_id');
    $image = $image ? ", image = '" . $image . "'" : '';

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);

    $sql = "UPDATE " . $dou->table('vote_option') . " SET name = '$_POST[name]'" . $image . " , sort = '$_POST[sort]', content = '$_POST[content]', number = '$_POST[number]', sort = '$_POST[sort]' WHERE option_id = '$option_id'";
    $dou->query($sql);

    $dou->create_admin_log($_LANG['vote_option_edit'] . ': ' . $_POST['name']);
    $dou->dou_header('vote.php?rec=option&vote_id=' . $_POST['vote_id']);
}    

/**
 * +----------------------------------------------------------
 * 自定义选项删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'option_del') {
    // 验证并获取合法的ID
    $option_id = $check->is_number($_REQUEST['option_id']) ? $_REQUEST['option_id'] : $dou->dou_msg($_LANG['illegal'], 'vote.php?rec=option&vote_id=' . $vote_id);
    $vote_id = $check->is_number($_REQUEST['vote_id']) ? $_REQUEST['vote_id'] : '';
 
    $name = $dou->get_one("SELECT name FROM " . $dou->table('vote_option') . " WHERE option_id = '$option_id'");
    
    if (isset($_POST['confirm']) ? $_POST['confirm'] : '') {
        $dou->create_admin_log($_LANG['vote_option_del'] . ': ' . $name);
        $dou->delete('vote_option', "option_id = $option_id", 'vote.php?rec=option&vote_id=' . $vote_id);
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], "vote.php?rec=option&vote_id=$vote_id", '', '30', "vote.php?rec=option_del&vote_id=$vote_id&option_id=$option_id");
    }
}

/**
 * +----------------------------------------------------------
 * 投票
 * +----------------------------------------------------------
 */
elseif ($rec == 'rank') {
    // 获取投票信息
    $vote_id = $check->is_number($_REQUEST['vote_id']) ? $_REQUEST['vote_id'] : '';
    $vote = $dou->get_row('vote', '*', "vote_id = '$vote_id'");
    
    $smarty->assign('ur_here', $vote['name'] . '.' . $_LANG['vote_rank']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['vote_list'],
            'href' => 'vote.php?rec=vote_list' 
    ));
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('vote_option') . " WHERE vote_id = '$vote_id' ORDER BY sort ASC, number ASC, option_id DESC";

    /* 获取资质证书列表 */
    $sql = $sql; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $poll = $dou->num_rows($dou->query("SELECT * FROM " . $dou->table('vote_log') . " WHERE option_id = '$row[option_id]'"));
        
        $vote_option_list[] = array (
                "option_id" => $row['option_id'],
                "name" => $row['name'],
                "image" => $GLOBALS['dou']->dou_file($row['image']),
                "content" => $row['content'],
                "number" => $row['number'] . $_LANG['vote_option_number_unit'],
                "poll" => $poll,
                "ip_voted" => $dou_vote->check_ip_voted($row['option_id'])
        );
    }
 
    // 重新排序
    array_multisort($dou_vote->array_column($vote_option_list, 'poll'), SORT_DESC, $vote_option_list);

    // 赋值给模板-数据
    $smarty->assign('vote_option_list', $vote_option_list);
    $smarty->assign('vote', $vote);

    $smarty->display('vote.htm');
}

?>