<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Vote {
    /**
     * +----------------------------------------------------------
     * 获取投票列表
     * +----------------------------------------------------------
     */
    function get_vote_list($cur_vote_id = '') {
        $sql = "SELECT vote_id, name FROM " . $GLOBALS['dou']->table('vote') . " ORDER BY vote_id ASC";
        $query = $GLOBALS['dou']->query($sql);
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $vote_list[] = array (
                    "vote_id" => $row['vote_id'],
                    "name" => $row['name'],
                    "cur" => $row['vote_id'] == $cur_vote_id ? true : false
            );
        }
        
        return $vote_list;
    }
 
    /**
     * +----------------------------------------------------------
     * 获取自定义选项
     * +----------------------------------------------------------
     */
    function get_vote_option_list($vote_id, $current_option_id = '') {
        $sql = "SELECT * FROM " . $GLOBALS['dou']->table('vote_option') . " WHERE vote_id = '$vote_id' ORDER BY sort ASC, option_id DESC";
        $query = $GLOBALS['dou']->query($sql);
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $vote_option_list[] = array (
                    "option_id" => $row['option_id'],
                    "name" => $row['name'],
                    "image" => $GLOBALS['dou']->dou_file($row['image']),
                    "content" => $row['content'],
                    "sort" => $row['sort']
            );
        }
        
        return $vote_option_list;
    }
    
    /**
     * +----------------------------------------------------------
     * 获取自定义选项
     * +----------------------------------------------------------
     */
    function get_option_name($vote_id) {
        $sql = "SELECT * FROM " . $GLOBALS['dou']->table('vote_option') . " WHERE vote_id = '$vote_id'";
        $query = $GLOBALS['dou']->query($sql);
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $option_name[$row['unique_id']] = $row['name'];
        }
        
        return $option_name;
    }
    
    /**
     * +----------------------------------------------------------
     * 判断投票是否开始
     * +----------------------------------------------------------
     */
    function check_vote_nostart($vote_id) {
        $start_time = $GLOBALS['dou']->get_one("SELECT start_time FROM " . $GLOBALS['dou']->table('vote') . " WHERE vote_id = '$vote_id'");
     
        if (time() < $start_time) return true;
    }
    
    /**
     * +----------------------------------------------------------
     * 判断投票是否结束
     * +----------------------------------------------------------
     */
    function check_vote_ended($vote_id) {
        $end_time = $GLOBALS['dou']->get_one("SELECT end_time FROM " . $GLOBALS['dou']->table('vote') . " WHERE vote_id = '$vote_id'");
     
        if (time() > $end_time) return true;
    }
    
    /**
     * +----------------------------------------------------------
     * 投票状态
     * +----------------------------------------------------------
     */
    function vote_time_status($vote_id) {
        if ($this->check_vote_nostart($vote_id)) {
            $status = $GLOBALS['_LANG']['vote_status_nostart'];
        } else {
            if ($this->check_vote_ended($vote_id)) {
                $status = $GLOBALS['_LANG']['vote_status_ended'];
            }
        }
        return $status;
    }
    
    /**
     * +----------------------------------------------------------
     * 判断IP是否已经投过票
     * +----------------------------------------------------------
     */
    function check_ip_voted($option_id) {
        $ip = $GLOBALS['dou']->get_ip();
        $number = $GLOBALS['dou']->num_rows($GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('vote_log') . " WHERE option_id = '$option_id' AND ip = '$ip'"));
     
        if ($number) return true;
    }
    
    /**
     * +----------------------------------------------------------
     * 验证每个IP最大投票数
     * +----------------------------------------------------------
     */
    function check_out_max_vote_number($vote_id, $ip) {
        // 该IP已经投票数
        $number = $GLOBALS['dou']->num_rows($GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('vote_log') . " WHERE vote_id = '$vote_id' AND ip = '$ip'"));
        
        // 该投票最多允许投票数
        $max_vote_number = $GLOBALS['dou']->get_one("SELECT max_vote_number FROM " . $GLOBALS['dou']->table('vote') . " WHERE vote_id = '$vote_id'");
     
        $max_vote_number_text = preg_replace('/d%/Ums', $max_vote_number, $GLOBALS['_LANG']['vote_max_vote_number']);
     
        if ($number >= $max_vote_number) return $max_vote_number_text;
    }
 
    /**
     * +----------------------------------------------------------
     * 验证每个IP最大投票数
     * +----------------------------------------------------------
     */
    function qrcode($vote_id) {
        $file = ROOT_PATH . 'images/vote_qrcode/vote_' . $vote_id . '.png';
        if (file_exists($file))
            return ROOT_URL . 'images/vote_qrcode/vote_' . $vote_id . '.png';
    }
 
    /**
     * +----------------------------------------------------------
     * 生成二维码
     * +----------------------------------------------------------
     */
    function create_qrcode($vote_id) {
        $path = ROOT_PATH . 'images/vote_qrcode/';
        if (!file_exists($path)) mkdir($path, 0777);
     
        include_once (ROOT_PATH . 'include/phpqrcode.class.php');
        $errorCorrectionLevel = 'H';//容错级别 
        $matrixPointSize = 10;//生成图片大小 
        $filename = $path . 'vote_' . $vote_id . '.png';
        $url = $GLOBALS['dou']->param($GLOBALS['dou']->rewrite_url('vote', 'detail') . '&vote_id=' . $vote_id);
     
        //生成二维码图片 
        QRcode::png($url, $filename, $errorCorrectionLevel, $matrixPointSize, 2); 
    }
 
    /**
     * +----------------------------------------------------------
     * 投票统计
     * +----------------------------------------------------------
     */
    function count_vote($vote_id) {
        // 参与候选人
        $count_vote['option'] = $GLOBALS['dou']->num_rows($GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('vote_option') . " WHERE vote_id = '$vote_id'"));
     
        // 累积票数
        $count_vote['log'] = $GLOBALS['dou']->num_rows($GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('vote_log') . " WHERE vote_id = '$vote_id'"));
     
        // 访问次数
        $count_vote['click'] = $GLOBALS['dou']->get_one("SELECT click FROM " . $GLOBALS['dou']->table('vote') . " WHERE vote_id = '$vote_id'");
     
        return $count_vote;
    }
 
    /**
     * +----------------------------------------------------------
     * 返回数组中某个单一列的值
     * +----------------------------------------------------------
     */
    function array_column($input, $columnKey, $indexKey = NULL) {
        $columnKeyIsNumber = (is_numeric($columnKey)) ? TRUE : FALSE;
        $indexKeyIsNull = (is_null($indexKey)) ? TRUE : FALSE;
        $indexKeyIsNumber = (is_numeric($indexKey)) ? TRUE : FALSE;
        $result = array();

        foreach ((array)$input AS $key => $row) { 
            if ($columnKeyIsNumber) {
                $tmp = array_slice($row, $columnKey, 1);
                $tmp = (is_array($tmp) && !empty($tmp)) ? current($tmp) : NULL;
            } else {
                $tmp = isset($row[$columnKey]) ? $row[$columnKey] : NULL;
            }
         
            if (!$indexKeyIsNull) {
                if ($indexKeyIsNumber) {
                    $key = array_slice($row, $indexKey, 1);
                    $key = (is_array($key) && ! empty($key)) ? current($key) : NULL;
                    $key = is_null($key) ? 0 : $key;
                } else {
                    $key = isset($row[$indexKey]) ? $row[$indexKey] : 0;
                }
            }

            $result[$key] = $tmp;
        }

        return $result;
    }
 
    /**
     * +----------------------------------------------------------
     * 输入换行符
     * +----------------------------------------------------------
     */
    function line_break($str) {
        $str = preg_replace('/\r\n/', '<br />', $str);
        $str = preg_replace('/\n/', '<br />', $str);
     
        return $str;
    }
    
}
?>