<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'detail|item|rank|view|submit';
$subbox = array(
        "module" => 'vote',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'vote';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 载入并实例化类库
require (ROOT_PATH . 'include/vote.class.php');
$dou_vote = new Vote();

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'vote', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 投票
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('vote') . $where . " ORDER BY sort ASC, vote_id DESC";

    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, ($_DISPLAY['vote'] ? $_DISPLAY['vote'] : 12), $page, $dou->rewrite_url('vote'), $get);

    /* 获取团队列表 */
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        // 多语言
        $row = $dou->lang_box($row, 'vote', 'name, content, description');
        
        $vote_list[] = array (
                "vote_id" => $row['vote_id'],
                "name" => $row['name'],
                "image" => $dou->dou_file($row['image']),
                "description" => $row['description'],
                "url" => $dou->rewrite_url('vote', $row['vote_id'])
        );
    }
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('vote'));
    $smarty->assign('ur_here', $dou->ur_here('vote'));
    $smarty->assign('vote_list', $vote_list);

    $smarty->display('vote.dwt');
}

/**
 * +----------------------------------------------------------
 * 投票介绍页
 * +----------------------------------------------------------
 */
if ($rec == 'detail') {
    // 验证并获取合法REQUEST
    $vote_id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';

    // 获取投票信息
    $vote = $dou->get_row('vote', '*', "vote_id = '$vote_id' AND status = '1'");
    $vote['item_url'] = $_URL['vote'] . '/item?vote_id=' . $vote_id;
    
    if (!$vote)
        $dou->dou_msg('page_wrong', HOME_URL);

    $vote['qrcode'] = $dou_vote->qrcode($vote_id);
 
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('vote', '', $vote['name']));
    $smarty->assign('ur_here', $dou->ur_here('vote', '', $vote['name']));
    $smarty->assign('head', $vote['name']);
    $smarty->assign('vote', $vote);
    $smarty->assign('count_vote', $dou_vote->count_vote($vote_id));
 
    $smarty->display('vote.dwt');
}

/**
 * +----------------------------------------------------------
 * 投票
 * +----------------------------------------------------------
 */
if ($rec == 'item') {
    // 验证并获取合法REQUEST
    $vote_id = $check->is_number($_REQUEST['vote_id']) ? $_REQUEST['vote_id'] : '';

    // 获取投票信息
    $vote = $dou->get_row('vote', '*', "vote_id = '$vote_id' AND status = '1'");

    if (!$vote)
        $dou->dou_msg('page_wrong', HOME_URL);

    if ($vote) {
        // 格式化数据
        $vote['start_time'] = date("Y-m-d H:i:s", $vote['start_time']);
        $vote['end_time'] = date("Y-m-d H:i:s", $vote['end_time']);
        $vote['max_vote_number_text'] = preg_replace('/d%/Ums', $vote['max_vote_number'], $_LANG['vote_max_vote_number']);

        // 链接
        $vote['url_vote'] = $dou->param($dou->rewrite_url('vote') . '&vote_id=' . $vote_id);
        $vote['url_rank'] = $dou->param($dou->rewrite_url('vote', 'rank') . '&vote_id=' . $vote_id);
        $vote['url_detail'] = $dou->param($dou->rewrite_url('vote', 'detail') . '&vote_id=' . $vote_id);
    }

    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('vote_option') . " WHERE vote_id = '$vote_id' ORDER BY sort ASC, number ASC, option_id DESC";

    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, ($_DISPLAY['vote'] ? $_DISPLAY['vote'] : 12), $page, $dou->rewrite_url('vote'));

    /* 获取资质证书列表 */
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $poll = $dou->num_rows($dou->query("SELECT * FROM " . $dou->table('vote_log') . " WHERE option_id = '$row[option_id]'"));
        
        $option_list[] = array (
                "option_id" => $row['option_id'],
                "name" => $row['name'],
                "image" => $GLOBALS['dou']->dou_file($row['image']),
                "content" => $row['content'],
                "number" => $row['number'] . $_LANG['vote_option_number_unit'],
                "poll" => $poll,
                "url" => $dou->param($dou->rewrite_url('vote', 'view') . '&vote_id=' . $row['vote_id'] . '&option_id=' . $row['option_id']),
                "ip_voted" => $dou_vote->check_ip_voted($row['option_id'])
        );
    }
 
    // 访问统计
    $click = $vote['click'] + 1;
    $dou->query("UPDATE " . $dou->table('vote') . " SET click = '$click' WHERE vote_id = '$vote_id'");
 
    // 投票状态
    $vote['time_status'] = $dou_vote->vote_time_status($vote_id);

    // 判断投票是否结束
    if ($dou_vote->check_vote_ended($vote_option['vote_id']))
        $vote['ended'] = true;
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('vote', '', $vote['name']));
    $smarty->assign('ur_here', $dou->ur_here('vote', '', $vote['name']));
    $smarty->assign('head', $vote['name']);
    $smarty->assign('option_list', $option_list);
    $smarty->assign('vote', $vote);
    $smarty->assign('count_vote', $dou_vote->count_vote($vote_id));

    $smarty->display('vote.dwt');
}

/**
 * +----------------------------------------------------------
 * 排行榜
 * +----------------------------------------------------------
 */
if ($rec == 'rank') {
    // 验证并获取合法REQUEST
    $vote_id = $check->is_number($_REQUEST['vote_id']) ? $_REQUEST['vote_id'] : '';

    // 获取投票信息
    $vote = $dou->get_row('vote', '*', "vote_id = '$vote_id' AND status = '1'");

    if (!$vote)
        $dou->dou_msg('page_wrong', HOME_URL);

    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('vote_option') . " WHERE vote_id = '$vote_id' ORDER BY sort ASC, number ASC, option_id DESC";

    /* 获取资质证书列表 */
    $sql = $sql; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $poll = $dou->num_rows($dou->query("SELECT * FROM " . $dou->table('vote_log') . " WHERE option_id = '$row[option_id]'"));
        
        $option_list[] = array (
                "option_id" => $row['option_id'],
                "name" => $row['name'],
                "image" => $GLOBALS['dou']->dou_file($row['image']),
                "content" => $row['content'],
                "number" => $row['number'] . $_LANG['vote_option_number_unit'],
                "poll" => $poll,
                "ip_voted" => $dou_vote->check_ip_voted($row['option_id'])
        );
    }
 
    // 重新排序
    array_multisort($dou_vote->array_column($option_list, 'poll'), SORT_DESC, $option_list);

    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('vote', '', $vote['name'] . $_LANG['vote_rank']));
    $smarty->assign('ur_here', $dou->ur_here('vote', '', $vote['name'] . $_LANG['vote_rank']));
    $smarty->assign('head', $_LANG['vote_rank']);
    $smarty->assign('option_list', $option_list);
    $smarty->assign('vote', $vote);

    $smarty->display('vote.dwt');
}

/**
 * +----------------------------------------------------------
 * 候选人介绍
 * +----------------------------------------------------------
 */
if ($rec == 'view') {
    // 获取请求值
    $vote_id = $check->is_number($_REQUEST['vote_id']) ? $_REQUEST['vote_id'] : '';
    $option_id = $check->is_number($_REQUEST['option_id']) ? $_REQUEST['option_id'] : 0;
 
    // 获取投票信息
    $vote = $dou->get_row('vote', '*', "vote_id = '$vote_id' AND status = '1'");
    $vote['item_url'] = $_URL['vote'] . '/item?vote_id=' . $vote_id;
    
    // 候选信息
    $vote_option = $dou->get_row('vote_option', '*', "option_id = '$option_id'");
    if (!$vote_option)
        $dou->dou_msg('page_wrong', HOME_URL);
    
    // 格式化数据
    $vote_option['number'] = $vote_option['number'] . $_LANG['vote_option_number_unit'];
    $vote_option['image'] = $dou->dou_file($vote_option['image']);
    $vote_option['content'] = $dou_vote->line_break($vote_option['content']);
    $vote_option['ip_voted'] = $dou_vote->check_ip_voted($option_id);
    $vote_option['poll'] = $dou->num_rows($dou->query("SELECT * FROM " . $dou->table('vote_log') . " WHERE option_id = '$option_id'"));
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('vote', '', $vote_option['name']));
    $smarty->assign('ur_here', $dou->ur_here('vote', '', $vote_option['name']));
    $smarty->assign('head', $vote_option['name']);
    $smarty->assign('vote', $vote);
    $smarty->assign('vote_option', $vote_option);
 
    $smarty->display('vote.dwt');
}

/**
 * +----------------------------------------------------------
 * 投票
 * +----------------------------------------------------------
 */
elseif ($rec == 'submit') {
    $option_id = $check->is_number($_POST['option_id']) ? $_POST['option_id'] : 0;
    if (!$dou->value_exist('vote_option', 'option_id', $option_id))
        exit;

    // 候选信息
    $vote_option = $dou->get_row('vote_option', '*', "option_id = '$option_id'");
    
    // 格式化数据
    $ip = $dou->get_ip();
    $vote_time = time();
 
    // 判断投票是否开始
    if ($dou_vote->check_vote_nostart($vote_option['vote_id']))
        die($_LANG['vote'] . $_LANG['vote_status_nostart']);
    
    // 判断投票是否结束
    if ($dou_vote->check_vote_ended($vote_option['vote_id']))
        die($_LANG['vote'] . $_LANG['vote_status_ended']);
    
    // 判断IP是否已经投过票
    if ($dou_vote->check_ip_voted($vote_option['option_id']))
        die($_LANG['vote_ip_voted']);
    
    // 判断IP是否已经投过票
    if ($dou_vote->check_ip_voted($vote_option['option_id']))
        die($_LANG['vote_ip_voted']);
    
    // 验证每个IP最大投票数
    if ($max_vote_number = $dou_vote->check_out_max_vote_number($vote_option['vote_id'], $ip))
        die($max_vote_number);
    
    $sql = "INSERT INTO " . $dou->table('vote_log') . " (id, vote_id, option_id, ip, vote_time)" . " VALUES (NULL, '$vote_option[vote_id]', '$vote_option[option_id]', '$ip', '$vote_time')";
    $dou->query($sql);
    
    // 当前排名
    $rank = $dou->num_rows($dou->query("SELECT * FROM " . $dou->table('vote_log') . " WHERE option_id = '$vote_option[option_id]'"));
 
    // 返回AJAX
    echo $rank;
}

?>