// pages/vote/item.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    option_list: [],
    page: 1, // 初始页默认值为1
    nomore: false
  },
  
  onLoad: function(options) {
    var that = this
        
    wx.setNavigationBarTitle({
      title: app.title.vote_item
    })

    // 显示转发按钮
    dou.showShareMenu()
        
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    if (options.vote_id) {
      that.setData({
        vote_id: options.vote_id
      })
    }
    
    that.loadData()
  },

  // 获取数据
  loadData: function(concat = false, page = '') {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'vote.php?rec=item',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        vote_id: that.data.vote_id,
        page: page ? page : that.data.page, // 从数据里获取当前页数
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (concat) {
          var dataBox = that.data.option_list; // 从data获取当前datalist数组
          var dataNew = res.data.option_list; // 从此次请求返回的数据中获取新数组
          
          if (dataNew) {
            dataBox = dataBox.concat(dataNew); // 合并数组
          } else {
            that.setData({
              nomore: true
            })
          }
        } else {
          dataBox = res.data.option_list;
        }
       
        that.setData({
          vote: res.data.vote,
          option_list: dataBox,
          count_vote: res.data.count_vote,
          loadpage: false
        })
       
        // 设置转发标题缓存
        wx.setStorageSync('shareTitle', res.data.vote.name)
      }
    })
  },
 
  douVote: function (e) {
    var that = this
    
    wx.request({
    url: app.mp_url + 'vote.php?rec=poll',
    data: {
      user_id: wx.getStorageSync('user_id'),
      shell: wx.getStorageSync('shell'),
      option_id: e.currentTarget.dataset.option_id
    },
    method:'POST',
    header: {
      'Connect-Key' : wx.getStorageSync('connect_key'),
      'Content-Type': 'application/x-www-form-urlencoded'
    },
    success: function (res) {
      if (res.data.wrong) {
        dou.douMsg(res.data.wrong)
      } else {
        that.setData({
          page: 1,
          nomore: false
        })
        
        that.loadData()
        
        dou.douMsg(res.data.msg)
      }
    }
   })
  },
 
  onReachBottom: function () { // 触底开始下一页
    var that = this;
    
    if (!that.data.nomore) {
      var page = that.data.page + 1; // 获取当前页数并+1
    
      that.setData({
        page: page, // 更新当前页数
        loadpage: true,//加载动画的显示
      })

      setTimeout (
        function() { //注意function这里不能缺少
          that.loadData(true); // 重新调用请求获取下一页数据
        },1000
      )
    }
  },

  // 设置转发标题
  onShareAppMessage: function (options) {
    return {
      title: wx.getStorageSync('shareTitle')
    }
  }

})